      program mainqqpythia
      include 'LesHouches.h'
      real * 8 parp,pari
      integer mstp,msti
      common/pypars/mstp(200),parp(200),msti(200),pari(200)
      integer MSTU,MSTJ
      double precision PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      integer maxev
      common/mcmaxev/maxev
c Set up PYTHIA to accept user processes
      call PYINIT('USER','','',0d0)
c Do not stop for errors
      mstu(22)=200
      call abegin
      do iev=1,maxev
         call pyevnt
c convert to hepevt common block
         call pyhepc(1)
c list the HEPEVT event
c          CALL PYLIST(5)
         call analize
      enddo
      call aend
      END

      subroutine countevents
      implicit none
      character * 6 string
      integer maxev
      common/mcmaxev/maxev
 1    continue
      read(unit=97,fmt='(a)',end=2) string
      if(string.eq.'<event') then
         maxev=maxev+1
         goto 1
      endif
      goto 1
 2    continue
      write(*,*) ' found ',maxev,' events in file'
      end


      subroutine UPINIT
      implicit none
      character * 50 file
      character * 6 string
      include 'LesHouches.h'
      integer ios
      integer MDCY,MDME,KFDP,pycomp
      double precision brat
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      external pycomp
      file='pwglhef.events'
      open(unit=97,file=file,status='old',iostat=ios)
      if(ios.ne.0) then
         write(*,*)' enter name of event file'
         read(*,'(a)') file
         open(unit=97,file=file,status='old')
      endif
      call countevents         ! If events are from a pipe cannot do this;
      rewind(97)
      call lhefreadhdr(97)
      if(lprup(1).eq.1004) then
c make D+ and D- stable (using PDG codes)
         mdcy(pycomp(411),1)=0
         mdcy(pycomp(-411),1)=0
c make D0 and D0bar stable
         mdcy(pycomp(421),1)=0
         mdcy(pycomp(-421),1)=0
      elseif(lprup(1).eq.1005) then
c make B+ and B- stable
         mdcy(pycomp(521),1)=0
         mdcy(pycomp(-521),1)=0
c make B0 and B0bar stable
         mdcy(pycomp(511),1)=0
         mdcy(pycomp(-511),1)=0
      endif
      end

      subroutine UPEVNT
      include 'LesHouches.h'
      integer ini
      call lhefreadev(97)
      end


      subroutine upveto
c pythia routine to abort event
      end
